# Nextcloud

> Nextcloud server, a safe home for all your data
>
> Nextcloud est un logiciel libre, de site d'hébergement de fichiers, et un fork
> du logiciel ownCloud. À l'origine accessible via WebDAV, n'importe quel
> navigateur web, ou des clients spécialisés, son architecture ouverte a permis
> de voir ses fonctionnalités s'étendre depuis ses origines. Fin 2018, il
> propose de nombreux services.
>
> -- <cite>[Github][github]</cite>

On peut trouver [la documentation ici][documentation].

## Aide

```sh
docker exec --user www-data -it nextcloud bash

docker-compose exec --user www-data nextcloud php occ db:add-missing-primary-keys
```

## Configuration

Il est possible de configurer certaines parties avec des variables d'environnement, mais ce n'est pas le cas de l'ensemble de la configuration.

Voici les modifications que j'effectue :

```
docker-compose exec --user www-data nextcloud-fpm ash
vi config/config.php
```
Ajout de la configuration suivante :
```
  'default_language' => 'fr',
  'default_locale' => 'fr_FR',
  'default_phone_region' => 'FR',
  'defaultapp' => 'files',
  'preview_max_x' => 2048,
  'preview_max_y' => 2048,
  'jpeg_quality' => 60,
```

Ajout de imagemagick :
```
docker-compose exec nextcloud-fpm apk add --no-cache imagemagick
```

ou

```
ssh <server>
docker exec nextcloud-fpm apk add --no-cache imagemagick
```

## PHP-FPM: remédier à server reached pm.max_children

https://buzut.net/php-fpm-server-reached-pm-max-children/

```
docker exec -it nextcloud-fpm ash
vi /usr/local/etc/php-fpm.d/www.conf
```

[github]: https://github.com/nextcloud/server
[documentation]: https://docs.nextcloud.com/server/latest/admin_manual/contents.html
[backup]: https://docs.nextcloud.com/server/latest/admin_manual/maintenance/backup.html
[restore]: https://docs.nextcloud.com/server/latest/admin_manual/maintenance/restore.html
